#version 330

// Input vertex attributes (from vertex shader)
in vec2 fragTexCoord;
in vec4 fragColor;

// Input uniform values
uniform sampler2D texture0;
uniform vec4 colDiffuse;

// Output fragment color
out vec4 finalColor;

uniform vec2 sizea = vec2(612, 336);


void main()
{
    // Normalized pixel coordinates (from 0 to 1)
    vec2 uv   = fragTexCoord * sizea.xy;
    vec4 sum  = vec4(0);
    vec4 post = vec4(0);
    vec2 p    = fragTexCoord;
    
    const float blurSize = 1.0 / 512.0;

    int rem_y = int(p.y) % 3;
    
    // Shite code because I suck
    //
    float back_r = texture(texture0, p).r;
    float back_g = texture(texture0, p).g;
    float back_b = texture(texture0, p).b;
    
    
    // NB: Strength of RGB separation, per channel. 0.0 = MAX; 1.0 = NONE
    //
    float blend_r = 0.60;
    float blend_g = 0.50;
    float blend_b = 0.50;
    
    
    // RGB split every 3 pixels
    //
    if(int(uv.x) % 3 == 0) { post = vec4(back_r, back_g * blend_r, back_b * blend_r, 1.0); }
    if(int(uv.x) % 3 == 1) { post = vec4(back_r * blend_g, back_g, back_b * blend_g, 1.0); }
    if(int(uv.x) % 3 == 2) { post = vec4(back_r * blend_b, back_g * blend_b, back_b, 1.0); }
       
    

    // Something to brighten the display (bloom)
    //
    // blur in y (vertical)
    // take nine samples, with the distance blurSize between them
    sum += texture(texture0, vec2(p.x - 4.0*blurSize, p.y)) * 0.05;
    sum += texture(texture0, vec2(p.x - 3.0*blurSize, p.y)) * 0.09;
    sum += texture(texture0, vec2(p.x - 2.0*blurSize, p.y)) * 0.12;
    sum += texture(texture0, vec2(p.x - blurSize, p.y)) * 0.15;
    sum += texture(texture0, vec2(p.x, p.y)) * 0.16;
    sum += texture(texture0, vec2(p.x + blurSize, p.y)) * 0.15;
    sum += texture(texture0, vec2(p.x + 2.0*blurSize, p.y)) * 0.12;
    sum += texture(texture0, vec2(p.x + 3.0*blurSize, p.y)) * 0.09;
    sum += texture(texture0, vec2(p.x + 4.0*blurSize, p.y)) * 0.05;
	
    // blur in y (vertical)
    // take nine samples, with the distance blurSize between them
    sum += texture(texture0, vec2(p.x, p.y - 4.0*blurSize)) * 0.05;
    sum += texture(texture0, vec2(p.x, p.y - 3.0*blurSize)) * 0.09;
    sum += texture(texture0, vec2(p.x, p.y - 2.0*blurSize)) * 0.12;
    sum += texture(texture0, vec2(p.x, p.y - blurSize)) * 0.15;
    sum += texture(texture0, vec2(p.x, p.y)) * 0.16;
    sum += texture(texture0, vec2(p.x, p.y + blurSize)) * 0.15;
    sum += texture(texture0, vec2(p.x, p.y + 2.0*blurSize)) * 0.12;
    sum += texture(texture0, vec2(p.x, p.y + 3.0*blurSize)) * 0.09;
    sum += texture(texture0, vec2(p.x, p.y + 4.0*blurSize)) * 0.05;

    post *= (sum * 1.50);
    

    // Scanlines
    //
    finalColor = vec4(post*colDiffuse*fragColor);

    finalColor.rgb -= mod(uv.y,3.0)<1.00 ? 0.25 : 0.000;
    
}